<cfsetting enablecfoutputonly="Yes">
<cfparam name="Attributes.output" default="html2js" type="string">
<cfparam name="Attributes.display" default="true" type="boolean">
<cfparam name="Attributes.addScriptTag" default="true" type="boolean">
<cfparam name="Attributes.stripWhitespace" default="true" type="boolean">
<cfparam name="Attributes.newLine" default="#chr(13)##chr(10)#" type="string">

<cfscript>
/***************************************************************
Name:   cf_html2js
Author: Dan G. Switzer, II
Date:   September 4, 2002

Description:
 This tag will take all the content generated between the 
 open/close tag pair and convert it to a JavaScript array. 
 Then it will output it to the browser using converting 
 the array to a string and using the browser's 
 document.write() method. 

 Use this tag to help generate html that is to be included 
 to the browser via an external .js file or simply 
 inserted via a JavaScript function. 

Attributes:
 output 
   The variable name to output the results to. This defaults 
	 to "html2js". 

 display 
   Boolean value indicating whether or not the output should 
	 automatically be displayed. (default: true) 

 addScriptTag 
   Boolean value indicating whether or not the output should 
	 contain start and ending <script> tags. If you use this 
	 tag between script tags or within an external .js file, 
	 set this attribute to false. (default: true) 

 stripWhitespace 
   Boolean value indicating whether or not the output should 
	 should have the miscellanous whitespacing on each line 
	 automatically removed. (default: true) 

 newLine 
   String value indicating what what the tag should consider 
	 the end of a line. (default: "#chr(13)##chr(10)#") 

***************************************************************/
switch( thisTag.executionMode ){
	case "end": {
		// copy the output to a variable
		sOutput = thisTag.generatedContent;
		// clear the output buffer
		thisTag.generatedContent = "";
		
		// strip out erraneous whitespace
		if( Attributes.stripWhitespace ){
			// strip whitespace on each side of the string
			sOutput = trim(sOutput);
			// remove extra whitespace at the beginning of a line
			sOutput = reReplace(sOutput, "(#chr(13)#?#chr(10)#)([ #chr(9)#]+)", "\1", "all");
			// remove extra whitespace at the end of a line
			sOutput = reReplace(sOutput, "([ #chr(9)#]+)(#chr(13)#?#chr(10)#)", "\2", "all");
			// remove empty blank lines
			sOutput = reReplace(sOutput, "(#chr(13)#?#chr(10)#)+", "\1", "all");
		}
		
		// convert string to an array
		aOutput = listToArray(sOutput, Attributes.newLine);
		
		// create an array to store the JavaScript in
		aJSArray = arrayNew(1);

		// generate the JavaScript variable
		aJSArray[arrayLen(aJSArray)+1] = "var _z = [];";
		for( i=1; i lte arrayLen(aOutput); i=i+1 ){
			aJSArray[arrayLen(aJSArray)+1] = "_z[_z.length] = """ & jsStringFormat(aOutput[i]) & """;";
		}
		// use the document.write() method to output results to the browser
		aJSArray[arrayLen(aJSArray)+1] = "document.write(_z.join(""\n""));";

		// copy the new array to the original variable
		sOutput = arrayToList(aJSArray, Attributes.newLine);
		
		// find any "<script>" tags and split them up
		sOutput = reReplaceNoCase(sOutput, "(<script)([^>]*>)", "<scr"" + ""ipt\2", "all");
		sOutput = reReplaceNoCase(sOutput, "(</script)([^>]*>)", "</scr"" + ""ipt\2", "all");
		

		// if adding the script tags, add them to the array
		if( Attributes.addScriptTag ){
			sOutput = "<script language=""JavaScript"">" & Attributes.newLine & "<!--//" & Attributes.newLine & sOutput;
			sOutput = sOutput & Attributes.newLine & "//-->"  & Attributes.newLine & "</script>" & Attributes.newLine;
		}

		// return the JavaScript string
		setVariable("caller." & Attributes.output, sOutput);
//		caller[Attributes.output] = sOutput;

		// check to see if the content should be outputted to the screen
		if( Attributes.display ) writeOutput(sOutput);
		
		break;
	}
}
</cfscript>
<cfsetting enablecfoutputonly="No">
